# Multi-Builder

Multi-Builder is a PS Vita LiveArea bubble creation and editing tool for Windows 10/11.

#### Bubbles available:
- Retroarch
- DaedalusX64
- FAKE08
- ScummVM
- YoYo Loader Vita
- EasyRPG Player Vita
- Flycast Vita
- Homebrew (editing only)
- Adrenaline Bubble Booter or Adrenaline Bubble Manager (editing only)


<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

#### Simply follow these steps:
1) Download the required images/files (Please see Supported File Types section)
2) Place them into the Input folder
3) Name images as: bg, icon0, and startup
   - Aspect ratio for images: bg = 15:9, startup/pic0 = 16:9, icon0 = 1:1
   - pic0 for Bubble-Builder only
   - YoYo-Builder uses .apk, .ini and/or .cfg files. NONE need to be renamed as of 1.5 and up.
4) Launch the Builder of choice from the Menu
5) Select Simple VPK
6) Name and add Title ID to the game of your choice
   - Rom or folder path may be required for RetroBuilder, Fake08-Builder and ScummVM-Builder
7) VPK will then generate in VPK folder
8) Transfer and install to the Vita.

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

#### Supported File Types:
<!-- Aligns table to center -->
<img align="left" width="225" height="100" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">

| Roms Files  | Image Files | Other Files |
| :---: | :---: | :---: |
| .gb  | .bmp  | .cfg  |
| .gbc  | .jpg  | .ini | 
| .gba  | .jpeg  | .apk | 
| .sms  | .jfif  | RPG Maker 00/03 | 
| .gen  | .tiff  | EasyRPG | 
| .bin  | .png  |
| .smd  |   |
| .gg  |   |
| .nes  |   |
| .smc  |   |
| .sfc  |   |
| .n64  |   |
| .v64  |   |
| .z64  |   |
| .gdi  |   |
| .cdi  |   |
| .chd  |   |

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>


<!-- MB Menu -->
<p align="center">
  <img src="https://user-images.githubusercontent.com/81541725/186501906-8a5964f3-b2a7-49c6-8ca9-46b4379001a6.png?raw=true" alt="Sublime's custom image"/>
</p>

<!-- Files -->
<p align="center">
  <img src="https://user-images.githubusercontent.com/81541725/165885346-12315363-02f6-4783-9686-514231d737b7.png?raw=true" alt="Sublime's custom image"/>
</p>

<!-- Bubble -->
<p align="center">
  <img src="https://user-images.githubusercontent.com/81541725/165674041-970872a2-9ef0-479d-9086-df648d977c1a.png?raw=true" alt="Sublime's custom image"/>
</p>

<!-- LiveArea -->
<p align="center">
  <img src="https://user-images.githubusercontent.com/81541725/165679344-e85249a5-b0e7-4d43-b794-fed002c511de.png?raw=true" alt="Sublime's custom image"/>
</p>

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

#### Options:

Eboot Updater - Keep your eboots update to date with YoYo Loader Vita Nightly builds.

Game Configuration - Create, modify and reset CFG files for YoYo-Builder.

Define Folder Path - Available for RetroBuilder, and ScummVM-Builder.

Define LiveArea Style - Available for all Builders.

Default Builder - Choose which Builder to open by default.

Rom Autopath - RetroBuilder, FAKE08-Builder and Flycast-Builder roms can be placed in the Input folder, paths will generate automatically based on filename.



<!-- <p align="center">
  <img src="https://user-images.githubusercontent.com/81541725/124930830-a8e90580-dfcf-11eb-980b-999fe3a546bc.png?raw=true" alt="RetroBuilder"/>
</p>
-->





<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>


# RetroBuilder

RetroBuilder allows anyone to create Retroarch and DaedalusX64 Bubbles easy.

Just place any supported ROM file and three required images into the Input folder.

![image](https://user-images.githubusercontent.com/81541725/169360811-b9fe496a-cffd-4b37-880d-1558b97f1497.png)
![image](https://user-images.githubusercontent.com/81541725/166613897-e364f51f-a47b-4242-9fa6-121aee33b852.png)

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>


# Fake08-Builder

Fake-08-Builder is a tool for Windows 10 that creates LiveArea Bubbles for Pico-8 carts on the PS Vita.

![image](https://user-images.githubusercontent.com/81541725/169360755-224d692c-5972-48fa-9827-4c24fb465c8c.png)
![image](https://user-images.githubusercontent.com/81541725/169360414-0f33c20f-3eef-433b-994f-39738c8508ff.png)


<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>


# ScummVM-Builder

ScummVM-Builder is a Windows 10 tool that creates custom LiveArea Bubbles for compatible PC games running on the ScummVM app for the PS Vita.

![image](https://user-images.githubusercontent.com/81541725/169360893-151d2a62-ebdc-4a67-97c3-64f30b95507a.png)
![image](https://user-images.githubusercontent.com/81541725/169361136-4b9bae11-c46b-493d-97ac-346947f0949d.png)

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>


# Bubble-Builder

Bubble-Builder is a total VPK re-packaging tool for Homebrew and Adrenaline Bubble Booter assets. PNGs, Title and IDs can now all be modified with ease on Windows 10/11.

Simply copy the Vita App of choice from ux0:app/ folder to Input/app-folder, download the required images to Input folder, and title/ID as needed (if VPK requires additional ux0:data folder, please select Y when prompted, otherwise select N). New VPK can then be generated and installed on the Vita.

![image](https://user-images.githubusercontent.com/81541725/169361242-48f7813a-279f-4bf1-9ca7-fb8dc3ffc5d5.png)
![image](https://user-images.githubusercontent.com/81541725/165886631-021afd50-a8f1-43a4-b9fb-2ffae488674d.png)

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

# YoYo-Builder

YoYo-Builder is a custom bubbles tool for Game Maker Studios games that are compatible with Yo-Yo Loader Vita.

![image](https://user-images.githubusercontent.com/81541725/165887109-2a210ef8-6d7e-47fb-88e3-877b65e88541.png)
![image](https://user-images.githubusercontent.com/81541725/169362622-6769874f-87e9-4132-a5d1-aadcebf09545.png)

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

# EasyRPG-Builder

EasyRPG-Builder is a custom bubbles tool that allows RPG Maker 2000/2003 and EasyRPG games to be played on PS Vita using EasyRPG Player Vita.

![image](https://user-images.githubusercontent.com/81541725/169355312-161a10a5-08a3-42cb-8073-0e3a26849b79.png)
![image](https://user-images.githubusercontent.com/81541725/169358236-4265b176-39b3-4d0d-a288-ff0cedf09b75.png)


<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

# Flycast-Builder

Flycast-Builder allows anyone to create Flycast Vita Bubbles easy.

Just place any supported ROM file and three required images into the Input folder.

![image](https://user-images.githubusercontent.com/81541725/186502141-1bee9c80-0cc6-4f8e-ae25-4ac4cd0c2d05.png)


<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>


## Shoutouts:

#### ** GENERAL SHOUTOUTS **

Devon - Thanks for all his help and listening to my ranting when something isn't working...until it does.

[dbenham](https://www.dostips.com/forum/viewtopic.php?f=3&t=6044) - Creating the JREPL batch file that allows template swapping, used in every builder.

Vita Nuova  Discord - Thanks for all the support, kind words and jokes :D

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

#### ** RETROBUILDER **

[SayianPrinceVegeta](https://www.youtube.com/channel/UCjnHt3Hiz7DUzXGwCHY3EWA) - Providing the inspiration for all of this and helping shape Simple VPK.

[u/W00lfwang](https://www.reddit.com/user/W00lfwang) - Detailing the RetroArch Bubble Booter method.

[u/histefanhere](https://www.reddit.com/u/histefanhere/)- RetroArch Bubble Booter method using python.

[Rinnegatamante](https://github.com/Rinnegatamante/DaedalusX64-vitaGL) - Porting DaedalusX64 and providing a method to create those Bubbles and everything else he does.

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>


#### ** FAKE08-BUILDER **

[jtothebell](https://github.com/jtothebell/fake-08) - Creator of Fake-08

[Lexaloffle Team](https://www.lexaloffle.com/pico-8.php) - Creators of Pico-8

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

#### ** SCUMMVM-BUILDER **

[ScummVM Team](https://github.com/scummvm/scummvm) - Creators of ScummVM

[cy33hc](https://github.com/cy33hc/scummvm-bubble-booter) - For creating the ScummVM Bubble Booter

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

#### ** BUBBLE-BUILDER **

[TheOfficialFloW](https://github.com/TheOfficialFloW) - Creator of Adrenaline

leecherman - Adrenaline Bubble Booter

ONElua - Adrenaline Bubble Manager

[ImageMagick](https://imagemagick.org/index.php) - Providing Composite.exe and Convert.exe

[7Zip](https://www.7-zip.org/) - Providing Zip2VPK tool

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

#### ** YOYO-BUILDER **

[Rinnegatamante](https://github.com/Rinnegatamante/yoyoloader_vita) - Creator of YoYo Loader Vita

<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

#### ** EASYRPG-BUILDER **

[EasyRPG](https://github.com/EasyRPG/Player) - Creator of EasyRPG Player

[Rinnegatamante](https://github.com/Rinnegatamante/easyrpg-player-vita) - Creator of EasyRPG Player Vita


<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

#### ** FLYCAST-BUILDER **

[Flyinghead](https://github.com/flyinghead/flycast) - Creator of Flycast

[Rinnegatamante](https://github.com/Rinnegatamante/flycast-vita) - Creator of Flycast Vita


<!-- Spacer -->
<p align="center">
  <img width="10" height="10" src="https://user-images.githubusercontent.com/81541725/168428087-611fe26a-aeb0-4617-98d7-9a239ea716d8.png">
</p>

#### Original Apps:

https://github.com/DRok17/RetroBuilder

https://github.com/DRok17/Fake-08-Builder

https://github.com/DRok17/ScummVM-Builder

https://github.com/DRok17/Bubble-Builder



